
const { ccclass, property } = cc._decorator;

@ccclass
export default class ShaderTime extends cc.Component {
    _material: cc.Material = null;

    @property
    _max: number = 1;

    isUpdate: boolean;

    @property
    get max(): number {
        return this._max;
    }
    set max(value) {
        this._max = value;
        // if (!CC_EDITOR) {
        //     return;
        // }

        // let sprite = this.node.getComponent(cc.Sprite);
        // if (sprite) {
        //     this._material = this.getComponent(cc.Sprite).getMaterial(0);
        //     // if (this._material._properties.time) {
        //     let material: any = sprite.getMaterial(0);;
        //     material.setProperty('timeTest', value);
        //     // }
        // }
    }

    private _start = 0;

    protected update(dt) {
        this._material = this.node.getComponent(cc.Sprite).getMaterial(0);
        // console.log('  this._material',  this._material);

        // if (this.node.active && this._material && this._material.effect._properties.timeTest) {
        if (this.node.active && this._material) {
            // console.log(11111111111);

            this._setShaderTime(dt);
        }
    }
    private _setShaderTime(dt) {
        let start = this._start;
        if (start > this.max) start = 0;
        start += 0.015;
        this._material.setProperty('timeTest', start);

        this._start = start;
    }
}
